在填充的给定索引处插入循环。 支持的平台:仅窗口 签名工 务 局: object.InsertLoopAt Index, LoopType, Loop
返回值(RetVal)无返回值。 言论没有额外的评论。 例子工 务 局: Sub Example_InsertLoopAt() ' This example creates an associative hatch in model space. ' A Loop is then inserted into the hatch. Dim hatchObj As AcadHatch Dim patternName As String Dim PatternType As Long Dim bAssociativity As Boolean ' Define the hatch patternName = "ANSI31" PatternType = 0 bAssociativity = True ' Create the associative Hatch object Set hatchObj = ThisDrawing.ModelSpace.AddHatch(PatternType, patternName, bAssociativity) ' Create the outer loop for the hatch. ' An arc and a line are used to create a closed loop. Dim outerLoop(0 To 1) As AcadEntity Dim center(0 To 2) As Double Dim radius As Double Dim startAngle As Double Dim endAngle As Double center(0) = 5: center(1) = 3: center(2) = 0 radius = 3 startAngle = 0 endAngle = 3.141592 Set outerLoop(0) = ThisDrawing.ModelSpace.AddArc(center, radius, startAngle, endAngle) Set outerLoop(1) = ThisDrawing.ModelSpace.AddLine(outerLoop(0).startPoint, outerLoop(0).endPoint) ' Append the outer loop to the hatch object hatchObj.AppendOuterLoop (outerLoop) ' Append the first circle as one inner loop Dim innerLoop1(0) As AcadEntity center(0) = 5: center(1) = 4.5: center(2) = 0 radius = 1 Set innerLoop1(0) = ThisDrawing.ModelSpace.AddCircle(center, radius) hatchObj.AppendInnerLoop (innerLoop1) ' Evaluate and display the hatch hatchObj.Evaluate ThisDrawing.Regen True MsgBox "Insert another loop.", , "InsertLoopAt Example" ' Insert the second circle as the other inner loop Dim LoopObj(0) As AcadEntity radius = 0.5 Set LoopObj(0) = ThisDrawing.ModelSpace.AddCircle(center, radius) hatchObj.InsertLoopAt hatchObj.NumberOfLoops, acHatchLoopTypeDefault, LoopObj ' Evaluate and display the hatch hatchObj.Evaluate ThisDrawing.Regen True MsgBox "Loop inserted.", , "InsertLoopAt Example" End Sub Visual LISP: (vl-load-com) (defun c:Example_InsertLoopAt() ;; This example creates an associative hatch in model space. ;; A Loop is then inserted into the hatch. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Define the hatch (setq patternName "ANSI31" patternType 0 bAssociativity :vlax-true) ;; Create the associative Hatch object (setq modelSpace (vla-get-ModelSpace doc)) (setq hatchObj (vla-AddHatch modelSpace patternType patternName bAssociativity acHatchObject)) ;; Create the outer loop for the hatch. ;; An arc and a line are used to create a closed loop. (setq center (vlax-3d-point 5 3 0) radius 3 startAngle 0 endAngle 3.141592) (setq arc (vla-AddArc modelSpace center radius startAngle endAngle)) (setq line (vla-AddLine modelSpace (vla-get-StartPoint arc) (vla-get-EndPoint arc))) (setq outerLoop (vlax-make-safearray vlax-vbObject '(0 . 1))) (vlax-safearray-put-element outerLoop 0 arc) (vlax-safearray-put-element outerLoop 1 line) ;; Append the outer loop to the hatch object (vla-AppendOuterLoop hatchObj outerLoop) ;; Append the first circle as one inner loop (setq center (vlax-3d-point 5 4.5 0) radius 1) (setq circle1 (vla-AddCircle modelSpace center radius)) (setq innerLoop1 (vlax-make-safearray vlax-vbObject '(0 . 0))) (vlax-safearray-put-element innerLoop1 0 circle1) (vla-AppendInnerLoop hatchObj innerLoop1) ;; Evaluate and display the hatch (vla-Evaluate hatchObj) (vla-Regen doc :vlax-true) (alert "Insert another loop.") ;; Insert the second circle as the other inner loop (setq radius 0.5) (setq LoopObj (vlax-make-safearray vlax-vbObject '(0 . 0))) (setq circle2 (vla-AddCircle modelSpace center radius)) (vlax-safearray-put-element LoopObj 0 circle2) (vla-InsertLoopAt hatchObj (vla-get-NumberOfLoops hatchObj) acHatchLoopTypeDefault LoopObj) ;; Evaluate and display the hatch (vla-Evaluate hatchObj) (vla-Regen doc :vlax-true) (alert "Loop inserted.") ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-8 19:50
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.